#!/bin/sh
# masterfile_uniform.sh
# Torque script to run Matlab program in Hotfoot.

# should type "cd /hmt/hpcstorage1/hpc/sscc/work/users/sk3404/exp_BKK" before submitting this job.

# Torque directives
#PBS -W group_list=hpcsscc
#PBS -l nodes=1:ppn=1,walltime=70:00:00,mem=8000mb

# output and error directories
#PBS -o localhost:/hmt/hpcstorage1/hpc/sscc/work/users/sk3404/exp_BKK
#PBS -e localhost:/hmt/hpcstorage1/hpc/sscc/work/users/sk3404/exp_BKK

# email notification options

#PBS -M sergei.kolbin@gmail.com
#PBS -m abe


# Command:
matlab -nosplash -nodisplay -nodesktop -r "BKK_mapping_search_noiv.m"> temp.txt
