     var c1 c2 c3 k1 k2 k3 l1 l2 l3 d1 d2 d3 f1 f2 f3 g1 g2 g3 r1 r2 r3 w1 w2 w3 x12 x13 x23 P1d P2d P3d P1f P2f P3f P1g P2g P3g             //
         pp1d pp2d pp3d pp1f pp2f pp3f pp1g pp2g pp3g lm1 lm2 lm3 z1 z2 z3 i1 i2 i3 T Tw Tot12 Tot13  T12p T13p T1b y1 y2;                                                                             
                                                                                                                                            
     varexo s1 s2 s3;                                                                                                                       
                                                                                                                                            
                       parameters alf sig dk gam bet eta lbar1 lbar2 lbar3 rho1 rho2 rho3 tau12 tau13 tau21 tau23 tau31 tau32               
               rho12 rho13 rho21 rho23 rho31 rho32 ome1d ome1f ome1g ome2d ome2f ome2g ome3d ome3f ome3g lbar x12ss x13ss //
               fi_df1 fi_fg1 fi_gd1 fi_df2 fi_fg2 fi_gd2 fi_df3 fi_fg3 fi_gd3 chi P1dss P2dss P3dss P1fss P2fss P3fss P1gss P2gss P3gss psi tax;                  
 
@#include "parameters.txt"

      model;                                                                                                                                
     //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                                                                  
     //CONSUMERS                                                                                                                            
     //Feasibility (Eq (1))                                                                                                                 
     -c1 -i1 + (ome1d*d1^((gam-1)/gam)+ome1f*(rho21*f1)^((gam-1)/gam)+ome1g*(rho31*g1)^((gam-1)/gam))^(gam/(gam-1)) //
     -fi_df1/2*(f1/d1*d1(-1)/f1(-1)-1)^2-fi_fg1/2*(f1/g1*g1(-1)/f1(-1)-1)^2-fi_gd1/2*(g1/d1*d1(-1)/g1(-1)-1)^2;       
     -c2 - i2 + (ome2d*(rho12*d2)^((gam-1)/gam)+ome2f*f2^((gam-1)/gam)+ome2g*(rho32*g2)^((gam-1)/gam))^(gam/(gam-1))//
     -fi_df2/2*(d2/f2*f2(-1)/d2(-1)-1)^2-fi_fg2/2*(g2/f2*f2(-1)/g2(-1)-1)^2-fi_gd2/2*(d2/g2*g2(-1)/d2(-1)-1)^2;       
     -c3 - i3 + (ome3d*(rho13*d3)^((gam-1)/gam)+ome3f*(rho23*f3)^((gam-1)/gam)+ome3g*g3^((gam-1)/gam))^(gam/(gam-1))//
     -fi_df3/2*(d3/f3*f3(-1)/d3(-1)-1)^2-fi_fg3/2*(f3/g3*g3(-1)/f3(-1)-1)^2-fi_gd3/2*(d3/g3*g3(-1)/d3(-1)-1)^2;       
     -k1 + (1-dk)*k1(-1)+i1- chi*k1(-1)*(i1/k1(-1)-dk)^2;
     -k2 + (1-dk)*k2(-1)+i2- chi*k2(-1)*(i2/k2(-1)-dk)^2;
     -k3 + (1-dk)*k3(-1)+i3- chi*k3(-1)*(i3/k3(-1)-dk)^2;     
                                                                                                                                            
     //Euler equations (Eq. (2))                                                                                                            
     bet*c1(+1)^(-sig)/(1-chi*(i1(+1)/k1-dk))*(r1(+1)+1-dk-chi/2*(dk^2-(i1(+1)/k1)^2))-//
     c1^(-sig)/(1-chi*(i1/k1(-1)-dk));                    
     bet*c2(+1)^(-sig)/(1-chi*(i2(+1)/k2-dk))*(r2(+1)+1-dk-chi/2*(dk^2-(i2(+1)/k2)^2))- //
     c2^(-sig)/(1-chi*(i2/k2(-1)-dk));                    
     bet*c3(+1)^(-sig)/(1-chi*(i3(+1)/k3-dk))*(r3(+1)+1-dk-chi/2*(dk^2-(i3(+1)/k3)^2))- //
     c3^(-sig)/(1-chi*(i3/k3(-1)-dk));                    
                                                                                                                                            
     //Static FOCs (Eq. (3))                                                                                                                
     (1-tax)*w1*c1^(-sig) - psi*l1^eta;                                                                                                         
     (1-tax)*w2*c2^(-sig) - psi*l2^eta;                                                                                                         
     (1-tax)*w3*c3^(-sig) - psi*l3^eta;                                                                                                         
                                                                                                                                            
     //Risk sharing (Eq. (7,8,9))                                                                                                           
     x12=c2^(-sig)/c1^(-sig)*x12ss;                                         
     x13=c3^(-sig)/c1^(-sig)*x13ss;                                         
     x23=(x13/x12);                                                                                                                         
                                                                                                                                            
     // Prices (Eq. (4,5,6))  
lm1=bet* c1(+1)^(-sig)/c1^(-sig);
lm2=bet* c2(+1)^(-sig)/c2^(-sig);  
lm3=bet* c3(+1)^(-sig)/c3^(-sig);  

     P1d+fi_df1*(f1/d1*d1(-1)/f1(-1)-1)*(-f1/d1^2)*d1(-1)/f1(-1)         +lm1*fi_df1*(f1(+1)/d1(+1)*d1/f1-1)*(f1(+1)/d1(+1)/f1) //
        +fi_gd1*(g1/d1*d1(-1)/g1(-1)-1)*(-g1/d1^2*d1(-1)/g1(-1))         +lm1*fi_gd1*(g1(+1)/d1(+1)*d1/g1-1)*g1(+1)/d1(+1)/g1    //
        = ome1d*d1^(-1/gam)*(ome1d*d1^((gam-1)/gam) + ome1f*(rho21*f1)^((gam-1)/gam)+ome1g*(rho31*g1)^((gam-1)/gam))^(1/(gam-1)) ;         
     P1f+fi_fg1*(f1/g1*g1(-1)/f1(-1)-1)*g1(-1)/g1/f1(-1)         +lm1*fi_fg1*(f1(+1)/g1(+1)*g1/f1-1)*(-f1(+1)/g1(+1)*g1/f1^2) //
        +fi_df1*(f1/d1*d1(-1)/f1(-1)-1)*(d1(-1)/f1(-1)/d1)       +lm1*fi_df1*(f1(+1)/d1(+1)*d1/f1-1)*(-f1(+1)/d1(+1)*d1/f1^2) //
        = ome1f*(rho21*f1)^(-1/gam)*(ome1d*d1^((gam-1)/gam) + ome1f*(rho21*f1)^((gam-1)/gam)+ome1g*(rho31*g1)^((gam-1)/gam))^(1/(gam-1));         
     P1g+fi_gd1*(g1/d1*d1(-1)/g1(-1)-1)*d1(-1)/d1/g1(-1)         +lm1*fi_gd1*(g1(+1)/d1(+1)*d1/g1-1)*(-g1(+1)/d1(+1)*d1/g1^2) //
        +fi_fg1*(f1/g1*g1(-1)/f1(-1)-1)*(-f1/g1^2*g1(-1)/f1(-1)) +lm1*fi_fg1*(f1(+1)/g1(+1)*g1/f1-1)*f1(+1)/g1(+1)/f1 //
        = ome1g*(rho31*g1)^(-1/gam)*(ome1d*d1^((gam-1)/gam) + ome1f*(rho21*f1)^((gam-1)/gam)+ome1g*(rho31*g1)^((gam-1)/gam))^(1/(gam-1));             
     P2d+fi_df2*(d2/f2*f2(-1)/d2(-1)-1)*f2(-1)/f2/d2(-1)         +lm2*fi_df2*(d2(+1)/f2(+1)*f2/d2-1)*(-d2(+1)/f2(+1)*f2/d2^2) //
        +fi_gd2*(d2/g2*g2(-1)/d2(-1)-1)*(g2(-1)/d2(-1)/g2) +lm2*fi_gd2*(d2(+1)/g2(+1)*g2/d2-1)*(-g2/d2^2*d2(+1)/g2(+1))    //
        = ome2d*(rho12*d2)^(-1/gam)*(ome2d*(rho12*d2)^((gam-1)/gam) + ome2f*f2^((gam-1)/gam)+ome2g*(rho32*g2)^((gam-1)/gam))^(1/(gam-1)) ;              
     P2f+fi_fg2*(g2/f2*f2(-1)/g2(-1)-1)*(-g2/f2^2*f2(-1)/g2(-1))         +lm2*fi_fg2*(g2(+1)/f2(+1)*f2/g2-1)*(g2(+1)/f2(+1)/g2) //
        +fi_df2*(d2/f2*f2(-1)/d2(-1)-1)*(-d2/f2^2*f2(-1)/d2(-1))         +lm2*fi_df2*(d2(+1)/f2(+1)*f2/d2-1)*d2(+1)/f2(+1)/d2 //
        = ome2f*f2^(-1/gam)*(ome2d*(rho12*d2)^((gam-1)/gam) + ome2f*f2^((gam-1)/gam)+ome2g*(rho32*g2)^((gam-1)/gam))^(1/(gam-1));       
     P2g+fi_gd2*(d2/g2*g2(-1)/d2(-1)-1)*(-g2(-1)/d2(-1)*d2/g2^2)         +lm2*fi_gd2*(d2(+1)/g2(+1)*g2/d2-1)*d2(+1)/g2(+1)*g2 //
        +fi_fg2*(g2/f2*f2(-1)/g2(-1)-1)*(f2(-1)/g2(-1)/f2)               +lm2*fi_fg2*(g2(+1)/f2(+1)*f2/g2-1)*(-g2(+1)/f2(+1)*f2/g2^2) //
        = ome2g*(rho32*g2)^(-1/gam)*(ome2d*(rho12*d2)^((gam-1)/gam) + ome2f*f2^((gam-1)/gam)+ome2g*(rho32*g2)^((gam-1)/gam))^(1/(gam-1));     
     P3d+fi_df3*(d3/f3*f3(-1)/d3(-1)-1)*f3(-1)/f3/d3(-1)         +lm2*fi_df3*(d3(+1)/f3(+1)*f3/d3-1)*(-d3(+1)/f3(+1)*f3/d3^2) //
        +fi_gd3*(d3/g3*g3(-1)/d3(-1)-1)*(d3(-1)/g3(-1)/g3)       +lm2*fi_gd3*(d3(+1)/g3(+1)*g3/d3-1)*(-d3(+1)/g3(+1)*g3/d3^2)    //
        = ome3d*(rho13*d3)^(-1/gam)*(ome3d*(rho13*d3)^((gam-1)/gam) + ome3f*(rho23*f3)^((gam-1)/gam)+ome3g*g3^((gam-1)/gam))^(1/(gam-1)) ;         
     P3f+fi_fg3*(f3/g3*g3(-1)/f3(-1)-1)*g3(-1)/g3/f3(-1)         +lm2*fi_fg3*(f3(+1)/g3(+1)*g3/f3-1)*(-f3(+1)/g3(+1)*g3/f3^2) //
        +fi_df3*(d3/f3*f3(-1)/d3(-1)-1)*(-d3/f3^2*f3(-1)/d3(-1)) +lm2*fi_df3*(d3(+1)/f3(+1)*f3/d3-1)*d3(+1)/f3(+1)/d3 //
        = ome3f*(rho23*f3)^(-1/gam)*(ome3d*(rho13*d3)^((gam-1)/gam) + ome3f*(rho23*f3)^((gam-1)/gam)+ome3g*g3^((gam-1)/gam))^(1/(gam-1));  
     P3g+fi_gd3*(d3/g3*g3(-1)/d3(-1)-1)*(-g3(-1)/d3(-1)*d3/g3^2)         +lm2*fi_gd3*(d3(+1)/g3(+1)*g3/d3-1)*(d3(+1)/g3(+1)/d3) //
        +fi_fg3*(f3/g3*g3(-1)/f3(-1)-1)*(-f3/g3^2*g3(-1)/f3(-1)) +lm2*fi_fg3*(f3(+1)/g3(+1)*g3/f3-1)*f3(+1)/g3(+1)/f3 //
        = ome3g*g3^(-1/gam)*(ome3d*(rho13*d3)^((gam-1)/gam) + ome3f*(rho23*f3)^((gam-1)/gam)+ome3g*g3^((gam-1)/gam))^(1/(gam-1));         
     // Consumer equations: 21                                                                                                              
     //-------------------------------------------------------------------------                                                            
     //PRODUCERS                                                                                                                            
                                                                                                                                            
    r1 = z1*pp1d*alf*k1^(alf-1)*l1^(1-alf);                                                                                                 
    w1 = z1*pp1d*(1-alf)*k1^alf*l1^(-alf);                                                                                                  
                                                                                                                                            
    r2 = z2*pp2f*alf*k2^(alf-1)*l2^(1-alf);                                                                                                 
    w2 = z2*pp2f*(1-alf)*k2^alf*l2^(-alf);                                                                                                  
                                                                                                                                            
    r3 = z3*pp3g*alf*k3^(alf-1)*l3^(1-alf);                                                                                                 
    w3 = z3*pp3g*(1-alf)*k3^alf*l3^(-alf);                                                                                                  
                                                                                                                                            
                                                                                                                                            
     // Number of equations: 6                                                                                                              
     //-------------------------------------------------------------------------                                                            
     //DISTRIBUTORS (Eq. (10))                                                                                                              
                                                                                                                                            
     pp1d=P1d;                                                                                                                              
P2d=(1+tau12)*pp2d/rho12;                                                                                                                   
P3d=(1+tau13)*pp3d/rho13;                                                                                                                   
                                                                                                                                            
P1f=(1+tau21)*pp1f/rho21;                                                                                                                   
     pp2f=P2f;                                                                                                                              
P3f=(1+tau23)*pp3f/rho23;                                                                                                                   
                                                                                                                                            
P1g=(1+tau31)*pp1g/rho31;                                                                                                                   
P2g=(1+tau23)*pp2g/rho23;                                                                                                                   
     pp3g=P3g;                                                                                                                              
                                                                                                                                            
     //LOOP (Eq. (11,12,13))                                                                                                                
                                                                                                                                            
    pp1d=x12*pp2d;                                                                                                                         
    pp1f=x12*pp2f;                                                                                                                         
    pp1g=x12*pp2g;                                                                                                                         
    pp1d=x13*pp3d;                                                                                                                          
    pp1f=x13*pp3f;                                                                                                                          
    pp1g=x13*pp3g;                                                                                                                          
                                                                                                                                            
     // Number of equations: 15                                                                                                             
     //-------------------------------------------------------------------------                                                            
     // FEASIBILITY                                                                                                                         
     lbar1*(d1) + lbar2*(d2) + lbar3*(d3) =  lbar1*z1*(k1^alf*l1^(1-alf));                                                                        
     lbar1*(f1) + lbar2*(f2) + lbar3*(f3) =  lbar2*z2*(k2^alf*l2^(1-alf));                                                                        
     lbar1*(g1) + lbar2*(g2) + lbar3*(g3) =  lbar3*z3*(k3^alf*l3^(1-alf));                                                                        
                                                                                                                                            
                                                                                                                                            
     //-------------------------------------------------------------------------                                                            
     //Shock process                                                                                                                        
     log(z1)=rho1*log(z1(-1))+s1;                                                                                                           
     log(z2)=rho2*log(z2(-1))+s2;                                                                                                           
     log(z3)=rho3*log(z3(-1))+s3;                                                                                                           
                                                                                                                                            
     
    Tw=(-0.5*x13*lbar3*(P3dss*d3+P3fss*f3+P3gss*g3-P3gss*z3*(k3^alf*l3^(1-alf)))/lbar1)/P1d;            
    T=(P1dss*d1+P1fss*f1+P1gss*g1-P1dss*z1*(k1^alf*l1^(1-alf)))/P1d-Tw;  
                                                                                                                                     
     Tot12=P1f/P1d;
     Tot13=P1g/P1d; 
     T12p=(1-Tot12)*f1;
     T13p=(1-Tot13)*g1;
     T1b=d1+f1+g1-T12p-T13p-z1*(k1^alf*l1^(1-alf)); 
     y1=z1*(k1^alf*l1^(1-alf));
     y2=z2*(k2^alf*l2^(1-alf));                                                                                                                                  
     //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                                                            
     end;                                                                                                                                   
                                                                                                                             
initval;                                                                                                               
@#include "initval.txt"
end;                                                                                                                         
steady(solve_algo=0);
shocks;
@#include "shocks.txt"
end;
  stoch_simul(ar=0, drop=100, periods=50001, irf=150, nograph, noprint,order=1,solve_algo=0);
