clear
clc
close all
global alf sig dk gam bet eta lbar1 lbar2 lbar3 rho1 rho2 rho3 psi tax ...
      tau12 tau13 tau21 tau23 tau31 tau32 rho12 rho13 rho21 rho23 rho31 rho32 ...
      ome1d ome1f ome1g ome2d ome2f ome2g ome3d ome3f ome3g lbar ...
      stderr1 stderr2 stderr3 corr12 corr13 corr23 ...
      fi_df1 fi_fg1 fi_gd1 fi_df2 fi_fg2 fi_gd2 fi_df3 fi_fg3 fi_gd3 chi
%
     
tax=0.;
     alf   =   0.36000000000000;
     sig   =   2.00000000000000; % RA
     dk    =   0.02500000000000;
        gam   =  1.17;

     bet   =   0.99000000000000;
     eta   =   1; % cons
     chi   =   4.2;
     psi   =   0.013;
%                                                                                                                    
     lbar1 =   1.00000000000000; % country size
     lbar2 =   1.00000000000000;
     lbar3 =   20.00000000000000;
%                                                                                       
     rho1  =   0.84; % shock process
     rho2  =   rho1;
     rho3  =   0.91;
%                                                                                                                        
     tau12 =   0.00000000000000;
     tau13 =   0.00000000000000;
     tau21 =   0.00000000000000;
     tau23 =   0.00000000000000;
     tau31 =   0.00000000000000;
     tau32 =   0.00000000000000;
%
     rho12 =   1.00000000000000;
     rho13 =   1.000000000000;
     rho21 =   1.00000000000000;
     rho23 =   1.000000000000;
     rho31 =   1.000000000000;
     rho32 =   1.000000000000;

     fi=0;

 fi12=fi;
 fi13=fi;
 fi23=0;
     fi_df1=fi12; fi_fg1=fi23; fi_gd1=fi13; 
     fi_df2=fi12; fi_fg2=fi13; fi_gd2=fi23; 
     fi_df3=fi23; fi_fg3=fi; fi_gd3=fi;

     

     t12=0;
     t13=0;
     tau12 =   t12;
     tau13 =   t13;
     tau21 =   t12;
     tau23 =   t13;
     tau31 =   t13;
     tau32 =   t13;

w11=0.8-0.02; %
w22=w11; %
w33=0.6333+0.046; %%

ome1d =   w11
ome1f =   (3-w11-w22-w33)/2-(1-w33)
ome1g =   (3-w11-w22-w33)/2-(1-w22)
ome2d =   (3-w11-w22-w33)/2-(1-w33);
ome2f =   w22;
ome2g =   (3-w11-w22-w33)/2-(1-w11);
ome3d =   (3-w11-w22-w33)/2-(1-w22);
ome3f =   (3-w11-w22-w33)/2-(1-w11);
ome3g =   w33;

     lbar  =  10.00000000000000;  % population     
corr12_i=0.52;
corr13_i= 0.66;
stderr1_i= 0.0096;
stderr3_i=0.00694;

stderr1=stderr1_i;
stderr2=stderr1_i;
stderr3=stderr3_i;
corr12=corr12_i;
corr13=corr13_i;
corr23=corr13_i;





save('BKK_parameters_GDP_11.mat', 'alf', 'sig', 'dk', 'gam', 'bet', 'eta', 'lbar1', 'lbar2', 'lbar3', 'rho1', 'rho2', 'rho3',...
     'tau12', 'tau13', 'tau21', 'tau23', 'tau31', 'tau32', 'rho12', 'rho13', 'rho21', 'rho23', 'rho31', 'rho32', ...
     'lbar',...
     'stderr1', 'stderr2', 'stderr3', 'corr12', 'corr13', 'corr23', 'chi')
load('xinit_11.mat','x','w11','w22','w33') 
x_guess=x;    
options=optimset('Display','iter','MaxFunEvals',45000,'MaxIter',1000);
[x,fval,exitflag,output,jacobian] = fsolve(@focsKR,x_guess,options);
if exitflag==1
    save('xinit_11.mat','x','w11','w22','w33')
end


%%%%%
%%%%%
%%%%%
x12ss=x(25)*((x(1)^eta*(lbar-x(7))^(1-eta))^(1-sig)/x(1))/((x(2)^eta*(lbar-x(8))^(1-eta))^(1-sig)/x(2));
x13ss=x(26)*((x(1)^eta*(lbar-x(7))^(1-eta))^(1-sig)/x(1))/((x(3)^eta*(lbar-x(9))^(1-eta))^(1-sig)/x(3));
[x(25),x(26)];
parameters_write;
initval_write;
shocks_write;

dynare BKK3C_fg2nfKR.mod

TT=exp(T);
TTw=exp(Tw);

T=50000;
t=10001;
c1_ss=oo_.steady_state(1); c2_ss=oo_.steady_state(2); c3_ss=oo_.steady_state(3);
c1_ss_init=oo_.steady_state(1); c2_ss_init=oo_.steady_state(2); c3_ss_init=oo_.steady_state(3);
k1_ss=oo_.steady_state(4); k2_ss=oo_.steady_state(5); k3_ss=oo_.steady_state(6);
l1_ss=oo_.steady_state(7); l2_ss=oo_.steady_state(8); l3_ss=oo_.steady_state(9);
d1_ss=oo_.steady_state(10); d2_ss=oo_.steady_state(11); d3_ss=oo_.steady_state(12); 
f1_ss=oo_.steady_state(13); f2_ss=oo_.steady_state(14); f3_ss=oo_.steady_state(15); 
g1_ss=oo_.steady_state(16); g2_ss=oo_.steady_state(17); g3_ss=oo_.steady_state(18); 
r1_ss=oo_.steady_state(19);   r2_ss=oo_.steady_state(20);   r3_ss=oo_.steady_state(21);   
w1_ss=oo_.steady_state(22);   w2_ss=oo_.steady_state(23);   w3_ss=oo_.steady_state(24);   
x12_ss=oo_.steady_state(25); x13_ss=oo_.steady_state(26); x23_ss=oo_.steady_state(27); 
P1d_ss=oo_.steady_state(28); P2d_ss=oo_.steady_state(29); P3d_ss=oo_.steady_state(30); 
P1f_ss=oo_.steady_state(31); P2f_ss=oo_.steady_state(32); P3f_ss=oo_.steady_state(33); 
P1g_ss=oo_.steady_state(34); P2g_ss=oo_.steady_state(35); P3g_ss=oo_.steady_state(36);
pp1d_ss=oo_.steady_state(37); pp2d_ss=oo_.steady_state(38); pp3d_ss=oo_.steady_state(39);
pp1f_ss=oo_.steady_state(40); pp2f_ss=oo_.steady_state(41); pp3f_ss=oo_.steady_state(42);
pp1g_ss=oo_.steady_state(43); pp2g_ss=oo_.steady_state(44); pp3g_ss=oo_.steady_state(45); 
i1_ss=oo_.steady_state(52);i2_ss=oo_.steady_state(53);
y1_ss=oo_.steady_state(62);y2_ss=oo_.steady_state(63);;Tot12_ss=oo_.steady_state(57);Tot13_ss=oo_.steady_state(58);
%z1 z2 z3 ;
%%% Steady state variables %%%
G1_ss=(ome1d*d1_ss.^((gam-1)/gam) + ome1f*(rho21*f1_ss).^((gam-1)/gam)+ome1g*(rho31*g1_ss).^((gam-1)/gam)).^(gam/(gam-1));                                                              
G2_ss=(ome2d*(rho12*d2_ss).^((gam-1)/gam) + ome2f*f2_ss.^((gam-1)/gam)+ome2g*(rho32*g2_ss).^((gam-1)/gam)).^(gam/(gam-1));                                                              
G3_ss=(ome3d*(rho13*d3_ss).^((gam-1)/gam) + ome3f*(rho23*f3_ss).^((gam-1)/gam)+ome3g*g3_ss.^((gam-1)/gam)).^(gam/(gam-1));                                                              
c1_ss= (P1d_ss*d1_ss+P1f_ss*f1_ss+P1g_ss*g1_ss).*c1_ss_init./G1_ss;                                                                                                          
c2_ss= (P2d_ss*d2_ss+P2f_ss*f2_ss+P2g_ss*g2_ss).*c2_ss_init./G2_ss;                                                                                                          
c3_ss= (P3d_ss*d3_ss+P3f_ss*f3_ss+P3g_ss*g3_ss).*c3_ss_init./G3_ss;
rGDP1_ss   = lbar1*(P1d_ss*d1_ss + P1f_ss*rho21*f1_ss + P1g_ss*rho31*g1_ss...                                                                                                       
         -pp1f_ss*f1_ss*(1+tau21)-pp1g_ss*g1_ss*(1+tau31))+lbar2*pp2d_ss*d2_ss*x12_ss+lbar3*pp3d_ss*d3_ss*x13_ss;                                                                                     
rGDP2_ss   = lbar2*(P2d_ss*rho12*d2_ss  +  P2f_ss*f2_ss + P2g_ss*rho32*g2_ss...                                                                                                        
         -pp2d_ss*d2_ss*(1+tau12)-pp2g_ss*g2_ss*(1+tau32))+lbar1*pp1f_ss*f1_ss/x12_ss+x23_ss*lbar3*pp3f_ss*f3_ss;                                                                                                
rGDP3_ss   = lbar3*(P3d_ss*rho13*d3_ss  +  P3f_ss*rho23*f3_ss + P3g_ss*g3_ss...                                                                                                        
         -pp3d_ss*d3_ss*(1+tau13)-pp3f_ss*f3_ss*(1+tau23)) + lbar1*pp1g_ss*g1_ss/x13_ss + lbar2*pp2g_ss*g2_ss/x23_ss; 
K1_ss=lbar1*k1_ss; K2_ss=lbar2*k2_ss; K3_ss=lbar3*k3_ss;                                                                                                      
L1_ss=lbar1*l1_ss; L2_ss=lbar2*l2_ss; L3_ss=lbar3*l3_ss;                                                                                                      
TFP1_ss= log(rGDP1_ss)-alf*log(K1_ss)-(1-alf)*log(L1_ss);                                                                                                 
TFP2_ss= log(rGDP2_ss)-alf*log(K2_ss)-(1-alf)*log(L2_ss);                                                                                                 
TFP3_ss= log(rGDP3_ss)-alf*log(K3_ss)-(1-alf)*log(L3_ss); 
     
     %%% Dynamic variables %%%
     d1m=d1(1:T-2);
     d1p=d1(2:T-1);
     d1pp=d1(3:T );
     f1m=f1(1:T-2);    
     f1p=f1(2:T-1);
     f1pp=f1(3:T );
     g1m=g1(1:T-2);
     g1p=g1(2:T-1);
     g1pp=g1(3:T);
     P1dp=P1d(2:T-1);
     P1fp=P1f(2:T-1);
     P1gp=P1g(2:T-1);
     lm1p=lm1(2:T-1);

TP1d= ome1d*d1.^(-1/gam).*(ome1d*d1.^((gam-1)/gam) + ome1f*(rho21*f1).^((gam-1)/gam)+ome1g*(rho31*g1).^((gam-1)/gam)).^(1/(gam-1)) ;         
TP1f= ome1f*(rho21.*f1).^(-1/gam).*(ome1d*d1.^((gam-1)/gam) + ome1f*(rho21*f1).^((gam-1)/gam)+ome1g*(rho31*g1).^((gam-1)/gam)).^(1/(gam-1));  
TP1g= ome1g*(rho31*g1).^(-1/gam).*(ome1d*d1.^((gam-1)/gam) + ome1f*(rho21*f1).^((gam-1)/gam)+ome1g*(rho31*g1).^((gam-1)/gam)).^(1/(gam-1));
mu1d=(TP1d-P1d)./TP1d;
mu1f=(TP1f-P1f)./TP1f;
mu1g=(TP1g-P1g)./TP1g;

G1=(ome1d*d1.^((gam-1)/gam) + ome1f*(rho21*f1).^((gam-1)/gam)+ome1g*(rho31*g1).^((gam-1)/gam)).^(gam/(gam-1));                                                              
G2=(ome2d*(rho12*d2).^((gam-1)/gam) + ome2f*f2.^((gam-1)/gam)+ome2g*(rho32*g2).^((gam-1)/gam)).^(gam/(gam-1));                                                              
G3=(ome3d*(rho13*d3).^((gam-1)/gam) + ome3f*(rho23*f3).^((gam-1)/gam)+ome3g*g3.^((gam-1)/gam)).^(gam/(gam-1));
c1= (P1d_ss*d1+P1f_ss*f1+P1g_ss*g1).*c1./G1;                                                                                                          
c2= (P2d_ss*d2+P2f_ss*f2+P2g_ss*g2).*c2./G2;                                                                                                          
c3= (P3d_ss*d3+P3f_ss*f3+P3g_ss*g3).*c3./G3;      
rGDP1   = lbar1*(P1d_ss*d1(:) + P1f_ss*rho21*f1(:) + P1g_ss*rho31*g1(:)...                                                                                                       
         -pp1f_ss*f1(:)*(1+tau21)-pp1g_ss*g1(:)*(1+tau31))+lbar2*pp2d_ss*d2(:)*x12_ss+lbar3*pp3d_ss*d3(:)*x13_ss;                                                                                     
rGDP2   = lbar2*(P2d_ss*rho12*d2(:)  +  P2f_ss*f2(:) + P2g_ss*rho32*g2(:)...                                                                                                        
         -pp2d_ss*d2(:)*(1+tau12)-pp2g_ss*g2(:)*(1+tau32))+lbar1*pp1f_ss*f1(:)/x12_ss+x23_ss*lbar3*pp3f_ss*f3(:);                                                                                                
rGDP3   = lbar3*(P3d_ss*rho13*d3(:)  +  P3f_ss*rho23*f3(:) + P3g_ss*g3(:)...                                                                                                        
         -pp3d_ss*d3(:)*(1+tau13)-pp3f_ss*f3(:)*(1+tau23)) + lbar1*pp1g_ss*g1(:)/x13_ss + lbar2*pp2g_ss*g2(:)/x23_ss;                                                                                            
nGDP1   = lbar1*(P1d(:).*d1(:)  +  rho21*P1f(:).*f1(:) + rho31*P1g(:).*g1(:)...                                                                                                     
         -pp1f(:).*f1(:)*(1+tau21)-pp1g(:).*g1(:)*(1+tau31))+lbar2*x12(:).*pp2d(:).*d2(:)+lbar3*x13(:).*pp3d(:).*d3(:);                                                                                         
nGDP2   = lbar2*(rho12*P2d(:).*d2(:)  +  P2f(:).*f2(:) + rho32*P2g(:).*g2(:)...                                                                                                     
         -pp2d(:).*d2(:)*(1+tau12)-pp2g(:).*g2(:)*(1+tau32))+lbar1*pp1f(:).*f1(:)./x12(:)+lbar3*x23(:).*pp3f(:).*f3(:);                                                                                          
nGDP3   = lbar3*(rho13*P3d(:).*d3(:)  +  rho23*P3f(:).*f3(:) + P3g(:).*g3(:)...                                                                                                     
         -pp3d(:).*d3(:)*(1+tau13)-pp3f(:).*f3(:)*(1+tau23))+lbar1*pp1g(:).*g1(:)./x13(:)+lbar2*pp2g(:).*g2(:)./x23(:);                                                                                                                                                             
K1=lbar1*k1; K2=lbar2*k2; K3=lbar3*k3;                                                                                                      
L1=lbar1*l1; L2=lbar2*l2; L3=lbar3*l3;                                                                                                      
TFP1(1:T)= log(rGDP1(1:T))-alf*log(K1(1:T))-(1-alf)*log(L1(1:T));                                                                                                 
TFP2(1:T)= log(rGDP2(1:T))-alf*log(K2(1:T))-(1-alf)*log(L2(1:T));                                                                                                 
TFP3(1:T)= log(rGDP3(1:T))-alf*log(K3(1:T))-(1-alf)*log(L3(1:T));                                                                                       
%Import/export shares                                                                                                                                                               
I21=(1+tau12)*pp1f_ss*lbar1*f1_ss/rGDP1_ss;                                                                                                                                                   
I31=(1+tau13)*pp1g_ss*lbar1*g1_ss/rGDP1_ss;                                                                                                                                                   
T21=((1+tau12)*pp1f_ss*lbar1*f1_ss+(1+tau12)*x12_ss*pp2d_ss*lbar2*d2_ss)/(rGDP1_ss+x12_ss*rGDP2_ss);                                                                                                    
T31=((1+tau13)*pp1g_ss*lbar1*g1_ss+(1+tau13)*x13_ss*pp3d_ss*lbar3*d3_ss)/(rGDP1_ss+x13_ss*rGDP3_ss);                                                                                                    
E12=x12_ss*pp2d_ss*lbar2*d2_ss; % not share, in home goods                                                                                                                                                     
E13=x13_ss*pp3d_ss*lbar3*d3_ss; % not share, in home goods                                                                                                                                                   
CPI1=((1-I21-I31)*P1d+I21*P1f+I31*P1g);
defGDP1 = nGDP1./rGDP1;                                                                                          
defGDP2 = nGDP2./rGDP2;                                                                                                                                                             
defGDP3 = nGDP3./rGDP3;                                                                                                                                                             
ep12     = x12.*pp2d./defGDP1;                                                                                                                                                     
ep13     = x13.*pp3d./defGDP1;                                                                                                                                                     
ip21     = pp1f./defGDP1;                                                                                                                                                          
ip31     = pp1g./defGDP1;                                                                                                                                                          
epi      = (E12*ep12+E13*ep13)/(E12+E13);                                                                                                                                           
ipi      = (I21*ip21+I31*ip31)/(I21+I31);                                                                                                                                   
LOOP12   = (x12.*pp2f)./pp1d;                                                                                                                                                       
LOOP13   = (x13.*pp3g)./pp1d;                                                                                                                                                       

%trade prices     

        defX=(x12.*pp2d.*lbar2.*d2+x13.*pp3d.*lbar3.*d3)./(x12_ss.*pp2d_ss.*lbar2.*d2+x13_ss.*pp3d_ss.*lbar3.*d3);
        Px     = defX./CPI1;  
        defM=(pp1f.*lbar1.*f1+pp1g.*lbar1.*g1)./(pp1f_ss.*lbar1.*f1+pp1g_ss.*lbar1.*g1);
        Pm     = defM./CPI1;
P      = Pm./Px;   
%tot and CA                                                                                                                                                                         
rer     = ( E12*x12 + E13*x13 )/(E12+E13);                                                                                                                                          
tot     = ipi./epi; %=P                                                                                                                                                    
CA      = exp( ( lbar2*x12.*pp2d.*d2+lbar3*x13.*pp3d.*d3-lbar1*pp1f.*f1-lbar1*pp1g.*g1 )./nGDP1 );                                                                                 
rCA     = exp( ( lbar2*x12_ss*pp2d_ss*d2+lbar3*x13_ss*pp3d_ss*d3-lbar1*pp1f_ss*f1-lbar1*pp1g_ss*g1 )./rGDP1 );                                                                    
tot12     = exp(ip21./ep12);                                                                                                                                                  
CA12      = exp( ( lbar2*x12.*pp2d.*d2-lbar1*pp1f.*f1)./nGDP1 );                                                                                 
rCA12     = exp( ( lbar2*x12_ss*pp2d_ss*d2-lbar1*pp1f_ss*f1)./rGDP1 );
CA13      = exp( ( lbar3*x13.*pp3d.*d3-lbar1*pp1g.*g1)./nGDP1 );                                                                                 
rCA13     = exp( ( lbar3*x13_ss*pp3d_ss*d3-lbar1*pp1g_ss*g1)./rGDP1 );
                                                                                                                                                                                    
inv1(1:T)=lbar1*(k1(2:T+1)-(1-dk)*k1(1:T));
inv2(1:T)=lbar2*(k2(2:T+1)-(1-dk)*k2(1:T));
inv3(1:T)=lbar3*(k3(2:T+1)-(1-dk)*k3(1:T));

i1= (P1d_ss*d1+P1f_ss*f1+P1g_ss*g1).*(i1./G1);                                                                                                                               
i2= (P2d_ss*d2+P2f_ss*f2+P2g_ss*g2).*(i2./G2);                                                                                                                               
i3= (P3d_ss*d3+P3f_ss*f3+P3g_ss*g3).*(i3./G3);   
   
ic1(1:T)=i1(1:T)+c1(1:T);
ic2(1:T)=i2(1:T)+c2(1:T);
ic3(1:T)=i3(1:T)+c3(1:T);
TS=[z1(t:T), z2(t:T), z3(t:T), exp(TFP1(t:T)'), exp(TFP2(t:T)'), exp(TFP3(t:T)'), rGDP1(t:T), rGDP2(t:T), rGDP3(t:T),...
    c1(t:T), c2(t:T), c3(t:T), l1(t:T), l2(t:T), l3(t:T), w1(t:T) w2(t:T) w3(t:T), ...
    CA(t:T), P(t:T), rer(t:T), Px(t:T), Pm(t:T),...
    k1(t:T), k2(t:T),k3(t:T),LOOP12(t:T),LOOP13(t:T),...
    ic1(t:T)',ic2(t:T)',ic3(t:T)',...
    CA12(t:T),rCA12(t:T),tot12(t:T),CA13(t:T),rCA13(t:T),...
    i1(t:T),i2(t:T),i3(t:T),c1(t:T),c2(t:T),d1(t:T),d2(t:T),f1(t:T),f2(t:T), TT(t:T), TTw(t:T)];
i_z1=1; i_z2=2; i_z3=3; i_TFP1=4; i_TFP2=5; i_TFP3=6; i_rGDP1=7; i_rGDP2=8; i_rGDP3=9;
i_c1=10; i_c2=11; i_c3=12; i_l1=13; i_l2=14; i_l3=15; i_w1=16; i_w2=17; i_w3=18;
i_CA=19; i_P=20; i_rer=21; i_Px=22; i_Pm=23;   
i_k1=24; i_k2=25; i_k3=26; i_LOOP12=27; i_LOOP13=28;
i_ci1=29; i_ci2=30; i_ci3=31;
i_CA12=32; i_rCA12=33; i_tot12=34; i_CA13=35; i_rCA13=36;
i_i1=37; i_i2=38; i_i3=39;
TS=log(TS);                                                                                                                                                 
[TS_t,TS_d]=hptrend(TS,1600);                                                                                                                                                       
dTS=TS_d;                                                                                                                                                                           
sd=100*std(dTS); 
cc= corrcoef(dTS); 
%%%%%
%%%%%
%%%%%
                                                                                                                                                                          

%COMPUTE autocorreltions
            L=128;
            periods=floor((T-t+1)/L-1);
            acor=zeros(periods,9);
            for ii=1:9
                for jj=1:periods
                    kk=(jj-1)*L+1;
                    a1=TS((kk+1):(kk+L-1),ii);
                    a2=TS((kk+1-1):(kk+L-1-1),ii);
                    a3=TS((kk+1-1):(kk+L-1),ii);
                    acor(jj,ii)=((a1-mean(a3))'*(a2-mean(a3)))/ ( (a3-mean(a3))'*(a3-mean(a3)) ) /(L-1)*L;
                end
            end
            acor=median(acor);

disp('   ')                                                                                                                                                                         
disp('   ')                                                                                                                                                                         
disp('   ')                                                                                                                                                                         
disp('========================================')                                                                                                                                    
disp('PARAMETERS:')                                                                                                                                                                 
fprintf('Alpha (capital share)        = %3.4f.\n',alf)                                                                                                                              
fprintf('Sigma (intertemporal elast.) = %3.4f.\n',sig)                                                                                                                              
fprintf('dk    (capital deprec.)      = %3.4f.\n',dk)                                                                                                                               
fprintf('Gamma (Armington elas.)      = %3.4f.\n',gam)                                                                                                                              
fprintf('Beta  (discount factor)      = %3.4f.\n',bet)                                                                                                                              
fprintf('Omega1d                      = %3.4f.\n',ome1d)                                                                                                                            
fprintf('Omega1f                      = %3.4f.\n',ome1f)                                                                                                                            
fprintf('Omega1g                      = %3.4f.\n',ome1g)                                                                                                                            
fprintf('Rho  (persistence)           = %3.4f.\n',rho1)                                                                                                                             
fprintf('Eta   (consumption share)    = %3.4f.\n',eta)                                                                                                                              
fprintf('Lbar1  (endowment of labor)  = %3.4f.\n',lbar1)                                                                                                                            
fprintf('Lbar2  (endowment of labor)  = %3.4f.\n',lbar2)                                                                                                                            
fprintf('Lbar3  (endowment of labor)  = %3.4f.\n',lbar3)                                                                                                                            
fprintf('tau   (tariff 1 2)               = %3.4f.\n',tau12)                                                                                                                        
fprintf('tau   (tariff 1 3)               = %3.4f.\n',tau13)                                                                                                                        
fprintf('tau   (tariff 2 3)               = %3.4f.\n',tau23)                                                                                                                        
disp('========================================')                                                                                                                                    
disp('   ')     

disp('========================================')                                                                                                                                    
disp('BUSINESS CYCLE VOLATILITY (IN PERCENT)')                                                                                                                                      
fprintf('s.d.(TFP1 assumed) = %3.7f\n',sd(i_z1))                                                                                                                             
fprintf('s.d.(TFP2 assumed) = %3.7f\n',sd(i_z2))                                                                                                                             
fprintf('s.d.(TFP3 assumed) = %3.7f\n',sd(i_z3))                                                                                                                             
fprintf('s.d.(TFP1 actual)  = %3.7f\n',sd(i_TFP1))                                                                                                                           
fprintf('s.d.(TFP2 actual)  = %3.7f\n',sd(i_TFP2))                                                                                                                           
fprintf('s.d.(TFP3 actual)  = %3.7f\n',sd(i_TFP3))                                                                                                                           
fprintf('s.d.(OUTPUT1)      = %3.7f\n',sd(i_rGDP1))                                                                                                                          
fprintf('s.d.(OUTPUT2)      = %3.7f\n',sd(i_rGDP2))                                                                                                                          
fprintf('s.d.(OUTPUT3)      = %3.7f\n',sd(i_rGDP3))                                                                                                                          
fprintf('s.d.(CONSUMPTION1) = %3.7f\n',sd(i_c1))                                                                                                                             
fprintf('s.d.(CONSUMPTION2) = %3.7f\n',sd(i_c2))                                                                                                                             
fprintf('s.d.(CONSUMPTION3) = %3.7f\n',sd(i_c3))  
fprintf('s.d.(INVESTMENT1)/sd(rGDP1)  = %3.7f\n',sd(i_i1)/sd(i_rGDP1))                                                                                                                                      
fprintf('s.d.(INVESTMENT2)  = %3.7f\n',sd(i_i2))                                                                                                                                      
fprintf('s.d.(INVESTMENT3)  = %3.7f\n',sd(i_i3))  
fprintf('s.d.(LABOR1)       = %3.7f\n',sd(i_l1))                                                                                                                             
fprintf('s.d.(LABOR2)       = %3.7f\n',sd(i_l2))                                                                                                                             
fprintf('s.d.(LABOR3)       = %3.7f\n',sd(i_l3))                                                                                                                             
fprintf('s.d.(CA 1)         = %3.7f\n',sd(i_CA))                                                                                                                             
fprintf('s.d.(TOT)          = %3.7f\n',sd(i_P))                                                                                                                              
fprintf('s.d.(RER)          = %3.7f\n',sd(i_rer))                                                                                                                            
fprintf('s.d.(Px)           = %3.7f\n',sd(i_Px))                                                                                                                             
fprintf('s.d.(Pm)           = %3.7f\n',sd(i_Pm))                                                                                                                             
fprintf('s.d.(W1)           = %3.7f\n',sd(i_w1))                                                                                                                             
fprintf('s.d.(W2)           = %3.7f\n',sd(i_w2))                                                                                                                             
fprintf('s.d.(W3)           = %3.7f\n',sd(i_w3))  

disp('=========================================')  
disp('INTERNATIONAL CORRELATIONS')                                                                                                                                                  
fprintf('corr(TFP assumed 1 2) = %.4f\n',cc(i_z1,i_z2))                                                                                                               
fprintf('corr(TFP assumed 1 3) = %.4f\n',cc(i_z1,i_z3))                                                                                                               
fprintf('corr(TFP assumed 2 3) = %.4f\n',cc(i_z2,i_z3))                                                                                                               
fprintf('corr(TFP actual 1 2)  = %.4f\n',cc(i_TFP1,i_TFP2))                                                                                                           
fprintf('corr(TFP actual 1 3)  = %.4f\n',cc(i_TFP1,i_TFP3))                                                                                                           
fprintf('corr(TFP actual 2 3)  = %.4f\n',cc(i_TFP3,i_TFP2))                                                                                                           
fprintf('corr(OUTPUT 1 2)      = %.4f\n',cc(i_rGDP1,i_rGDP2))                                                                                                         
fprintf('corr(OUTPUT 1 3)      = %.4f\n',cc(i_rGDP1,i_rGDP3))                                                                                                         
fprintf('corr(OUTPUT 2 3)      = %.4f\n',cc(i_rGDP2,i_rGDP3))                                                                                                         
fprintf('corr(CONSUMPTION 1 2) = %.4f\n',cc(i_c1,i_c2))                                                                                                               
fprintf('corr(CONSUMPTION 1 3) = %.4f\n',cc(i_c1,i_c3))                                                                                                               
fprintf('corr(CONSUMPTION 2 3) = %.4f\n',cc(i_c2,i_c3))  
fprintf('corr(INVESTMENT 1 2)  = %.4f\n',cc(i_i1,i_i2))  
fprintf('corr(INVESTMENT 1 3)  = %.4f\n',cc(i_i1,i_i3))  
fprintf('corr(INVESTMENT 2 3)  = %.4f\n',cc(i_i2,i_i3))  
fprintf('corr(LABOR 1 2)       = %.4f\n',cc(i_l1,i_l2))                                                                                                               
fprintf('corr(LABOR 1 3)       = %.4f\n',cc(i_l1,i_l3))                                                                                                               
fprintf('corr(LABOR 2 3)       = %.4f\n',cc(i_l2,i_l3))                                                                                                               
fprintf('corr(CAPITAL 1 2)     = %.4f\n',cc(i_k1,i_k2))                                                                                                               
fprintf('corr(CAPITAL 1 3)     = %.4f\n',cc(i_k1,i_k3))                                                                                                               
fprintf('corr(CAPITAL 2 3)     = %.4f\n',cc(i_k2,i_k3))                                                                                                               
fprintf('corr(Px,Pm)           = %.4f\n',cc(i_Px,i_Pm))                                                                                                               
                                                                                                                                                                                    
disp('=========================================')                                                                                                                                  
disp('BUSINESS CYCLE CORRELATIONS')                                                                                                                                                 
fprintf('corr(OUTPUT,CONS.)= %.4f\n',cc(i_rGDP1,i_c1))  
fprintf('corr(OUTPUT,INV.) = %.4f\n',cc(i_rGDP1,i_i1))   
fprintf('corr(OUTPUT,LABOR)= %.4f\n',cc(i_rGDP1,i_l1))                                                                                                                
fprintf('corr(OUTPUT,CA)   = %.4f\n',cc(i_rGDP1,i_CA))                                                                                                                
fprintf('corr(TOT,CA)      = %.4f\n',cc(i_P,i_CA))                                                                                                                   
fprintf('corr(TOT,GDP)     = %3.7f\n',cc(i_P,i_rGDP1)) 
fprintf('corr(TOT,GDP)     = %3.7f\n',cc(i_P,i_rGDP2))
fprintf('acorr(TFP 1 assumed)= %.4f\n',acor(1))    
fprintf('acorr(TFP 2 assumed)= %.4f\n',acor(2))   
fprintf('acorr(TFP 3 assumed)= %.4f\n',acor(3))   
fprintf('acorr(TFP 1 actual)= %.4f\n',acor(4))    
fprintf('acorr(TFP 2 actual)= %.4f\n',acor(5))   
fprintf('acorr(TFP 3 actual)= %.4f\n',acor(6)) 
fprintf('acorr(GDP 1)= %.4f\n',acor(7))    
fprintf('acorr(GDP 2)= %.4f\n',acor(8))   
fprintf('acorr(GDP 3)= %.4f\n',acor(9))                                                                                                              
                                                                                                                                                                                    
disp('=========================================')                                                                                                                                   
disp('Data has been logged & HP filtered (1600) except CA, ')                                                                                                                       
disp('CA has been divided by nom. GDP and then HP filtered.  ')                                                                                                                     
disp('   ')                                                                                                                                                                         
disp('STEADY STATE STATISTICS')                                                                                                                                                     
fprintf('1A. Imports/GDP      = %3.4f%%\n', 100*(I21+I31))                                                                                                                          
fprintf('1B. Imports from 2/GDP      = %3.4f%%\n', 100*(I21))                                                                                                                       
fprintf('1C. Imports from 3/GDP      = %3.4f%%\n', 100*(I31))                                                                                                                       
fprintf('1D. Trade intensity with 2      = %3.4f%%\n', 100*(T21))                                                                                                                   
fprintf('1E. Trade intensity with 3      = %3.4f%%\n', 100*(T31))                                                                                                                   
fprintf('4. sd(LOOP12) = %.4f%%\n',  sd(i_LOOP12))                                                                                                                          
fprintf('4. sd(LOOP13) = %.4f%%\n',  sd(i_LOOP13))                                                                                                                           
fprintf('8a. work time 1          = %3.4f%%\n', 100*l1_ss/lbar)                                                                                                          
fprintf('8b. work time 2          = %3.4f%%\n', 100*l2_ss/lbar)                                                                                                          
fprintf('8c. work time 3          = %3.4f%%\n', 100*l3_ss/lbar)                                                                                                          
fprintf('9. GDP3/GDP1             = %3.4f\n', rGDP3_ss/rGDP1_ss)                                                                                                                    
fprintf('9. GDP2/GDP1             = %3.4f\n', rGDP2_ss/rGDP1_ss)                                                                                                                    
fprintf('9. sdPx/sdrer            = %3.4f%%\n', 100*sd(i_Px)/sd(i_rer))                                                                                               
%domestic absorption                                                                                                                                                                
rDA =rGDP1-x12_ss*lbar2*pp2d_ss*d2(:)-x13_ss*lbar3*pp3d_ss*d3(:);                                                                                                                   
nDA =nGDP1-lbar2*x12.*pp2d.*d2-lbar3*x13.*pp3d.*d3;                                                                                                                                
PDA=nDA./rDA;                                                                                                                                                                      
%Armington elasticity                                                                                                                                                               
RATdf   = rDA./(pp1f_ss*lbar1*f1(:)+pp1g_ss*lbar1*g1(:));                                                                                                                           
RATpfpd = Pm./PDA;                                                                                                                                                                  
regA=[RATdf,RATpfpd];                                                                                                                                                              
regA=log(regA);                                                                                                                                                                    
dregA=regA-hptrend(regA,1600);                                                                                                                                                      
fprintf('10. sd(DA/imp)/sd(Pda/Pm)   = %3.4f%%\n', 100*std(dregA(t:T,1))/std(dregA(t:T,2))) 

disp('=========================================') 
fprintf('sd(T) = %.4f\n',sd(46)) 
fprintf('sd(Tw) = %.4f\n',sd(47)) 
fprintf('corr(T,GDP1) = %.4f\n',cc(46,i_rGDP1)) 
fprintf('corr(Tw,GDP1) = %.4f\n',cc(47,i_rGDP1)) 
                                                                                                                                                                                

disp('=========================================')   

disp('   ')                                                                                                                                                 
disp('--MArkups--')         %3.7f\n                                                                                                                                    
fprintf('std(mu_1d)/P1d_ss = %3.4f%%\n', std(mu1d)/P1d_ss*100)
fprintf('std(mu_1f)/P1f_ss = %3.4f%%\n', std(mu1f)/P1f_ss*100)
fprintf('std(mu_1g)/P1g_ss = %3.4f%%\n', std(mu1g)/P1g_ss*100)

Data=[cc(i_rGDP1,i_rGDP2);cc(i_rGDP1,i_rGDP3);cc(i_rGDP3,i_rGDP2);T21;T31];
fid6 = fopen('Data90_117KR.txt','w');
fprintf(fid6, '%.4f\n', Data');
fclose(fid6);

i1_s2=i1_s2/i1_ss;
i2_s2=i2_s2/i2_ss;
T_s2=T_s2/y1_ss;
c1_s2=c1_s2/c1_ss;
c2_s2=c2_s2/c2_ss;
k1_s2=k1_s2/k1_ss;
k2_s2=k2_s2/k2_ss;
l1_s2=l1_s2/l1_ss;
l2_s2=l2_s2/l2_ss;
y1_s2=y1_s2/y1_ss;
y2_s2=y2_s2/y2_ss;
Tw_s2=Tw_s2/y1_ss;
filename='IRFs_nof_3cKR.xlsx'

T = table (i1_s2,i2_s2,T_s2,c1_s2,c2_s2,k1_s2,k2_s2,y1_s2,y2_s2,l1_s2,l2_s2,Tw_s2,Tot12_s2/Tot12_ss,Tot13_s2/Tot13_ss);
writetable(T,filename,'Sheet',2,'Range','A1')

