%This file generates the data underlying Figure 9 in the paper for the DTE
%model. Cases below correspond to different values of short run elasticity

clc 
clear
close all
cd ./BKK_Model_friction_cases/
 BKK_friction_p90_c1
 BKK_friction_p50_c1
 cd ..
 delete Cases.mat
 p90_1      =load('./BKK_Model_friction_cases/Data90.txt');
 p50_1      =load('./BKK_Model_friction_cases/Data50.txt');
 save( 'Cases.mat','p90_1','p50_1')
 cd ./BKK_Model_friction_cases/
 BKK_friction_p90_c2
 BKK_friction_p50_c2
 cd ..
 p90_2      =load('./BKK_Model_friction_cases/Data90.txt');
 p50_2      =load('./BKK_Model_friction_cases/Data50.txt');
 save( 'Cases.mat','p90_2','p50_2','-append')
 cd ./BKK_Model_friction_cases/
 BKK_friction_p90_c3
 BKK_friction_p50_c3
 cd ..
 p90_3      =load('./BKK_Model_friction_cases/Data90.txt');
 p50_3      =load('./BKK_Model_friction_cases/Data50.txt');
 save( 'Cases.mat','p90_3','p50_3','-append')
 cd ./BKK_Model_friction_cases/
 BKK_friction_p90_c4
 BKK_friction_p50_c4
 cd ..
 p90_4      =load('./BKK_Model_friction_cases/Data90.txt');
 p50_4      =load('./BKK_Model_friction_cases/Data50.txt');
 save( 'Cases.mat','p90_4','p50_4','-append')
 cd ./BKK_Model_friction_cases/
 BKK_friction_p90_c5
 BKK_friction_p50_c5
 cd ..
 p90_5      =load('./BKK_Model_friction_cases/Data90.txt');
 p50_5      =load('./BKK_Model_friction_cases/Data50.txt');
 save( 'Cases.mat','p90_5','p50_5','-append')
 cd ./BKK_Model_friction_cases/
 BKK_friction_p90_c6
 BKK_friction_p50_c6
 cd ..
 p90_6      =load('./BKK_Model_friction_cases/Data90.txt');
 p50_6      =load('./BKK_Model_friction_cases/Data50.txt'); 
 save( 'Cases.mat','p90_6','p50_6','-append')
 cd ./BKK_Model_friction_cases/
 BKK_friction_p90_c7
 BKK_friction_p50_c7
 cd ..
 p90_7      =load('./BKK_Model_friction_cases/Data90.txt');
 p50_7      =load('./BKK_Model_friction_cases/Data50.txt'); 
 save( 'Cases.mat','p90_7','p50_7','-append')
 cd ./BKK_Model_friction_cases/
 BKK_friction_p90_c8
 BKK_friction_p50_c8 
 cd ..
 p90_8      =load('./BKK_Model_friction_cases/Data90.txt');
 p50_8      =load('./BKK_Model_friction_cases/Data50.txt');
 save( 'Cases.mat','p90_8','p50_8','-append')


 clear
 load Cases.mat

slopeM1=(p90_1(1)-p50_1(1))/(log(p90_1(4))-log(p50_1(4)));
slopeM2=(p90_2(1)-p50_2(1))/(log(p90_2(4))-log(p50_2(4)));
slopeM3=(p90_3(1)-p50_3(1))/(log(p90_3(4))-log(p50_3(4)));
slopeM4=(p90_4(1)-p50_4(1))/(log(p90_4(4))-log(p50_4(4)));
slopeM5=(p90_5(1)-p50_5(1))/(log(p90_5(4))-log(p50_5(4)));
slopeM6=(p90_6(1)-p50_6(1))/(log(p90_6(4))-log(p50_6(4)));
slopeM7=(p90_7(1)-p50_7(1))/(log(p90_7(4))-log(p50_7(4)));
slopeM8=(p90_8(1)-p50_8(1))/(log(p90_8(4))-log(p50_8(4)));


slopeD=0.034;
disp('Ratio of coefficients Model/Data for BKK with friction, autarky, GHH, etc')
Ratio1=slopeM1/slopeD
Ratio2=slopeM2/slopeD
Ratio3=slopeM3/slopeD
Ratio4=slopeM4/slopeD
Ratio5=slopeM5/slopeD
Ratio6=slopeM6/slopeD
Ratio7=slopeM7/slopeD
Ratio8=slopeM8/slopeD


Fractions=[Ratio1, Ratio2, Ratio3, Ratio4, Ratio5, Ratio6, Ratio7, Ratio8];







