 function F=focs(x) 

 global alf sig dk gam bet eta lbar1 lbar2 lbar3 rho1 rho2 rho3 psi tax ...
       tau12 tau13 tau21 tau23 tau31 tau32 rho12 rho13 rho21 rho23 rho31 rho32 ...
       ome1d ome1f ome1g ome2d ome2f ome2g ome3d ome3f ome3g lbar w11 w22 w33

     c1=x(1);
     c2=x(2);
     c3=x(3);
     k1=x(4);
     k2=x(5);
     k3=x(6);
     l1=x(7);
     l2=x(8);
     l3=x(9);
     d1=x(10);
     d2=x(11);
     d3=x(12);
     f1=x(13);
     f2=x(14);
     f3=x(15);
     g1=x(16);
     g2=x(17);
     g3=x(18);
     r1=x(19);
     r2=x(20);
     r3=x(21);
     w1=x(22);
     w2=x(23);
     w3=x(24);
     x12=x(25);
     x13=x(26);
     x23=x(27);
     P1d=x(28);
     P2d=x(29);
     P3d=x(30);
     P1f=x(31);
     P2f=x(32);
     P3f=x(33);
     P1g=x(34);
     P2g=x(35);
     P3g=x(36);
     pp1d=x(37);
     pp2d=x(38);
     pp3d=x(39);
     pp1f=x(40);
     pp2f=x(41);
     pp3f=x(42);
     pp1g=x(43);
     pp2g=x(44);
     pp3g=x(45);
     lm1=x(46);
     lm2=x(47);
     lm3=x(48);
     
     %CONSUMERS                                                                                                                            
     %Feasibility (Eq (1))
     F=[-c1 - k1 + (ome1d*d1^((gam-1)/gam)+ome1f*(rho21*f1)^((gam-1)/gam)+ome1g*(rho31*g1)^((gam-1)/gam))^(gam/(gam-1)) + (1-dk)*k1;       
     -c2 - k2 + (ome2d*(rho12*d2)^((gam-1)/gam)+ome2f*f2^((gam-1)/gam)+ome2g*(rho32*g2)^((gam-1)/gam))^(gam/(gam-1)) + (1-dk)*k2;       
     -c3 - k3 + (ome3d*(rho13*d3)^((gam-1)/gam)+ome3f*(rho23*f3)^((gam-1)/gam)+ome3g*g3^((gam-1)/gam))^(gam/(gam-1)) + (1-dk)*k3;                                                                                                                                                   
     %Euler equations (Eq. (2))                                                                                                            
     bet*(r1+1-dk)- 1;                    
     bet*(r2+1-dk)- 1;                    
     bet*(r3+1-dk)- 1;                    
     %Static FOCs (Eq. (3))                                                                                                                
     (1-tax)*w1*c1^(-sig) - psi*l1^eta;                                                                                                         
     (1-tax)*w2*c2^(-sig) - psi*l2^eta;                                                                                                         
     (1-tax)*w3*c3^(-sig) - psi*l3^eta;                                                                                                         
     %Risk sharing (Eq. (7,8,9))                                                                                                           
     %-x12+(1/c2*(c2^eta*(lbar-l2)^(1-eta))^(1-sig))/(1/c1*(c1^eta*(lbar-l1)^(1-eta))^(1-sig))*x12ss;                                         
     %-x13+(1/c3*(c3^eta*(lbar-l3)^(1-eta))^(1-sig))/(1/c1*(c1^eta*(lbar-l1)^(1-eta))^(1-sig))*x13ss;                                         
     -x23+(x13/x12);                                                                                                                         
     lbar1*pp1f*f1+lbar1*pp1g*g1-lbar2*pp2d*x12*d2-lbar3*pp3d*x13*d3;
     lbar2*pp2d*d2+lbar2*pp2g*g2-lbar1*pp1f/x12*f1-lbar3*pp3f*x23*f3;
          % Prices (Eq. (4,5,6))     
lm1-bet; % int steady state only !!!!!!
lm2-bet; % int steady state only !!!!!! 
lm3-bet; % int steady state only !!!!!!                                                                                                              
     -P1d + ome1d*d1^(-1/gam)*(ome1d*d1^((gam-1)/gam) + ome1f*(rho21*f1)^((gam-1)/gam)+ome1g*(rho31*g1)^((gam-1)/gam))^(1/(gam-1)) ;         
     -P1f + ome1f*(rho21*f1)^(-1/gam)*(ome1d*d1^((gam-1)/gam) + ome1f*(rho21*f1)^((gam-1)/gam)+ome1g*(rho31*g1)^((gam-1)/gam))^(1/(gam-1));  
     -P1g + ome1g*(rho31*g1)^(-1/gam)*(ome1d*d1^((gam-1)/gam) + ome1f*(rho21*f1)^((gam-1)/gam)+ome1g*(rho31*g1)^((gam-1)/gam))^(1/(gam-1));  
     -P2d + ome2d*(rho12*d2)^(-1/gam)*(ome2d*(rho12*d2)^((gam-1)/gam) + ome2f*f2^((gam-1)/gam)+ome2g*(rho32*g2)^((gam-1)/gam))^(1/(gam-1));  
     -P2f + ome2f*f2^(-1/gam)*(ome2d*(rho12*d2)^((gam-1)/gam) + ome2f*f2^((gam-1)/gam)+ome2g*(rho32*g2)^((gam-1)/gam))^(1/(gam-1));          
     -P2g + ome2g*(rho32*g2)^(-1/gam)*(ome2d*(rho12*d2)^((gam-1)/gam) + ome2f*f2^((gam-1)/gam)+ome2g*(rho32*g2)^((gam-1)/gam))^(1/(gam-1));  
     -P3d + ome3d*(rho13*d3)^(-1/gam)*(ome3d*(rho13*d3)^((gam-1)/gam) + ome3f*(rho23*f3)^((gam-1)/gam)+ome3g*g3^((gam-1)/gam))^(1/(gam-1));  
     -P3f + ome3f*(rho23*f3)^(-1/gam)*(ome3d*(rho13*d3)^((gam-1)/gam) + ome3f*(rho23*f3)^((gam-1)/gam)+ome3g*g3^((gam-1)/gam))^(1/(gam-1));  
     -P3g + ome3g*g3^(-1/gam)*(ome3d*(rho13*d3)^((gam-1)/gam) + ome3f*(rho23*f3)^((gam-1)/gam)+ome3g*g3^((gam-1)/gam))^(1/(gam-1));          
    %PRODUCERS   
    -r1 + pp1d*alf*k1^(alf-1)*l1^(1-alf);                                                                                                 
    -w1 + pp1d*(1-alf)*k1^alf*l1^(-alf);                                                                                                                                
    -r2 + pp2f*alf*k2^(alf-1)*l2^(1-alf);                                                                                                 
    -w2 + pp2f*(1-alf)*k2^alf*l2^(-alf);                                                                                                         
    -r3 + pp3g*alf*k3^(alf-1)*l3^(1-alf);                                                                                                 
    -w3 + pp3g*(1-alf)*k3^alf*l3^(-alf);                                                          
    %DISTRIBUTORS (Eq. (10))                                                                                                               
     -pp1d+P1d;                                                                                                                              
-P2d+(1+tau12)*pp2d/rho12;                                                                                                                   
-P3d+(1+tau13)*pp3d/rho13;                                                                                                                   
-P1f+(1+tau21)*pp1f/rho21;                                                                                                                   
     -pp2f+P2f;                                                                                                                              
-P3f+(1+tau23)*pp3f/rho23;                                                                                                                    
-P1g+(1+tau31)*pp1g/rho31;                                                                                                                   
-P2g+(1+tau32)*pp2g/rho32;                                                                                                                   
     -pp3g+P3g;                                                                                                                              
     %LOOP (Eq. (11,12,13))                                                                                                                 
     -pp1d+x12*pp2d;                                                                                                                         
     -pp1f+x12*pp2f;                                                                                                                         
     -pp1g+x12*pp2g;                                                                                                                         
    -pp1d+x13*pp3d;                                                                                                                          
    -pp1f+x13*pp3f;                                                                                                                          
    -pp1g+x13*pp3g;                                                                   
     % FEASIBILITY                                                                                                                         
     lbar1*d1 + lbar2*d2 + lbar3*d3 -  lbar1*(k1^alf*l1^(1-alf));                                                                        
     lbar1*f1 + lbar2*f2 + lbar3*f3 -  lbar2*(k2^alf*l2^(1-alf));                                                                        
     lbar1*g1 + lbar2*g2 + lbar3*g3 -  lbar3*(k3^alf*l3^(1-alf))];                                                                        
                                                                                                
          