clear
clc
close all
global alf sig dk gam bet eta lbar1 lbar2 lbar3 rho1 rho2 rho3 ...
      tau12 tau13 tau21 tau23 tau31 tau32 rho12 rho13 rho21 rho23 rho31 rho32 ...
      ome1d ome1f ome1g ome2d ome2f ome2g ome3d ome3f ome3g lbar ...
      stderr1 stderr2 stderr3 corr12 corr13 corr23 ...
      fi_df1 fi_fg1 fi_gd1 fi_df2 fi_fg2 fi_gd2 fi_df3 fi_fg3 fi_gd3 chi
%
     alf   =   0.36000000000000;
     sig   =   2.00000000000000; % RA
     dk    =   0.02500000000000;
        gam   =  10;

     bet   =   0.99000000000000;
     eta   =   0.33241853; % cons
     chi   =0.83;
%                                                                                                                    
     lbar1 =   1.00000000000000; % country size
     lbar2 =   1.00000000000000;
     lbar3 =   20.00000000000000;
                                                                                                                   
     tau12 =   0.00000000000000;
     tau13 =   0.00000000000000;
     tau21 =   0.00000000000000;
     tau23 =   0.00000000000000;
     tau31 =   0.00000000000000;
     tau32 =   0.00000000000000;
%
     rho12 =   1.00000000000000;
     rho13 =   1.000000000000;
     rho21 =   1.00000000000000;
     rho23 =   1.000000000000;
     rho31 =   1.000000000000;
     rho32 =   1.000000000000;

     fi=0;

    fi12=fi;
    fi13=fi;
    fi23=0;
     fi_df1=fi12; fi_fg1=fi23; fi_gd1=fi13; 
     fi_df2=fi12; fi_fg2=fi13; fi_gd2=fi23; 
     fi_df3=fi23; fi_fg3=fi; fi_gd3=fi;

     

     t12=0;
     t13=0;
     tau12 =   t12;
     tau13 =   t13;
     tau21 =   t12;
     tau23 =   t13;
     tau31 =   t13;
     tau32 =   t13;

w11=0.4251; %
w22=w11; %
w33=0.39; %

ome1d =   w11
ome1f =   (3-w11-w22-w33)/2-(1-w33)
ome1g =   (3-w11-w22-w33)/2-(1-w22)
ome2d =   (3-w11-w22-w33)/2-(1-w33);
ome2f =   w22;
ome2g =   (3-w11-w22-w33)/2-(1-w11);
ome3d =   (3-w11-w22-w33)/2-(1-w22);
ome3f =   (3-w11-w22-w33)/2-(1-w11);
ome3g =   w33;

     lbar  =  10.00000000000000;  % population     
     
     
%                                                                                       
rho1  =   0.83;
rho2  =   rho1;
rho3  =   0.898;
%     
corr12_i=0.585;
corr13_i= 0.737;
stderr1_i= 0.00727;
stderr3_i=0.00547;

stderr1=stderr1_i;
stderr2=stderr1_i;
stderr3=stderr3_i;
corr12=corr12_i;
corr13=corr13_i;
corr23=corr13_i;





save('BKK_parameters_GDP_11.mat', 'alf', 'sig', 'dk', 'gam', 'bet', 'eta', 'lbar1', 'lbar2', 'lbar3', 'rho1', 'rho2', 'rho3',...
     'tau12', 'tau13', 'tau21', 'tau23', 'tau31', 'tau32', 'rho12', 'rho13', 'rho21', 'rho23', 'rho31', 'rho32', ...
     'lbar',...
     'stderr1', 'stderr2', 'stderr3', 'corr12', 'corr13', 'corr23', 'chi')
load('xinit_11_a.mat','x','w11','w22','w33') 
x_guess=x;    
options=optimset('Display','iter','MaxFunEvals',45000,'MaxIter',1000);
[x,fval,exitflag,output,jacobian] = fsolve(@focs,x_guess,options);
if exitflag==1
    save('xinit_11_a.mat','x','w11','w22','w33')
end


%%%%%
%%%%%
%%%%%
x12ss=x(25)*((x(1)^eta*(lbar-x(7))^(1-eta))^(1-sig)/x(1))/((x(2)^eta*(lbar-x(8))^(1-eta))^(1-sig)/x(2));
x13ss=x(26)*((x(1)^eta*(lbar-x(7))^(1-eta))^(1-sig)/x(1))/((x(3)^eta*(lbar-x(9))^(1-eta))^(1-sig)/x(3));
[x(25),x(26)];
parameters_write;
initval_write;
shocks_write;
dynare BKK3C_fg2nf.mod
p50stats

