(* ::Package:: *)

(* ::Input:: *)
(*(*:Name: Manipulation tools for lists of equations*)*)
(*(*:Authors: Drozd, Kolbin and Nosal*)*)
(*(*:Last updated: Dec 2019*)*)


(* ::Input:: *)
(*BeginPackage["`Mantools`"]*)


(* ::Input:: *)
(*Begin["`Private`"]*)


(* ::Input:: *)
(*AllLeft::usage="AllLeft[expr] moves all terms of an expression to the lefthand side of ==."*)


(* ::Input:: *)
(*CleanList::usage="CleanList[expr] cleans a list by dropping items have logical value true."*)


(* ::Input:: *)
(*EliminateVar::usage="EliminateVar[expr,num,var] solves for a selected variable var using equation num from the list expr and substitutes out in the rest of the list."*)


(* ::Input:: *)
(*ExtractVar::usage="ExtractVar[expr,num,var] solves for a selected variable var using num equation from the list of equations."*)


(* ::Input:: *)
(*AllLeft[expr_]:=Table[ expr[[i,1]]-expr[[i,2]]==0,{i,1,Length[expr]}]*)


(* ::Input:: *)
(*EliminateVar[expr_,num1_,var_]:=Module[{plugin,expr2},plugin=Solve[expr[[num1]],var];expr2=expr/.plugin[[1]];Delete[expr2,num1]]*)


(* ::Input:: *)
(*ExtractVar[expr_,num1_,var_]:=Module[{plugin},plugin=Solve[expr[[num1]],var]; ReplacePart[expr,num1-> plugin[[1,1,1]]==plugin[[1,1,2]]]];*)


(* ::Input:: *)
(*CleanList[x_]:=Module[{del},del=Position[x,True];Delete[x,del]] *)


(* ::Input:: *)
(*End[]*)


(* ::Input:: *)
(*EndPackage[]*)
